Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #1569 (new defect)

Opened 14 years ago

Last modified 14 years ago

ACK frame have 2 missing bytes at the end (monitor mode)

Reported by: Mister_X Assigned to:
Priority: minor Milestone:
Component: madwifi: driver Version: trunk
Keywords: Cc:
Patch is attached: 0 Pending:

Description

In monitor mode, captured ACK frames have 2 missing bytes at the end. This started with r2487 (r2486 was working ok).

2 files will be attached to this ticket containing an ACK captured using latest trunk:

  • one with r2487 reverted
  • another without any patch applied

The same node is acked in both frames.

Attachments

clean.pcap (192 bytes) - added by Mister_X on 09/27/07 23:36:44.
No patch applied (2 missing bytes)
reverted.pcap (194 bytes) - added by Mister_X on 09/27/07 23:37:47.
r2487 reverted - ACK frame is OK
rx_capture_restrict_pad_removal_to_wds_frames.patch (0.6 kB) - added by jal2@gmx.de on 09/28/07 14:31:05.
Signed-off-by: Joerg Albert <jal2@gmx.de>
rx_capture_restrict_pad_removal_to_wds_and_qos_frames.patch (0.6 kB) - added by jal2@gmx.de on 09/29/07 01:37:01.
extend padding removal to QoS data packets. Signed-off-by: Joerg Albert <jal2@gmx.de>
madwifi-nopad_control_frames.diff (2.9 kB) - added by mentor on 11/16/07 00:42:10.
madwifi-nopad_control_frames.2.diff (4.1 kB) - added by mentor on 11/28/07 21:49:21.
Merged up to r2990

Change History

09/27/07 23:36:44 changed by Mister_X

  • attachment clean.pcap added.

No patch applied (2 missing bytes)

09/27/07 23:37:47 changed by Mister_X

  • attachment reverted.pcap added.

r2487 reverted - ACK frame is OK

09/28/07 14:28:18 changed by jal2@gmx.de

The comment to svn r2487 talks about WDS frames, but the procedure ath_rx_capture doesn't check for it. I'll attach a patch against svn r2708 which applies pad removal only if ToDS and FromDS are set.

Mister_X, please test it.

Maybe proski could comment on it, as I have no information on when the hardware adds any padding.

09/28/07 14:31:05 changed by jal2@gmx.de

  • attachment rx_capture_restrict_pad_removal_to_wds_frames.patch added.

Signed-off-by: Joerg Albert <jal2@gmx.de>

09/29/07 01:37:01 changed by jal2@gmx.de

  • attachment rx_capture_restrict_pad_removal_to_wds_and_qos_frames.patch added.

extend padding removal to QoS data packets. Signed-off-by: Joerg Albert <jal2@gmx.de>

09/29/07 01:40:36 changed by jal2@gmx.de

Added a second patch which obsoletes the first one. It removes padding only for WDS frames and data frames with QoS. This patch fixes corrupt CTS frames in monitor mode in svn r2708 for me.

Mister_X, please test it.

(follow-up: ↓ 4 ) 09/29/07 15:55:02 changed by Mister_X

The first patch didn't work at all.

The second one seems to be working (I just did a quick capture) but I need to test it a bit more to confirm it works ;).

(in reply to: ↑ 3 ) 10/01/07 12:05:03 changed by jal2@gmx.de

Replying to Mister_X:

The first patch didn't work at all. The second one seems to be working (I just did a quick capture) but I need to test it a bit more to confirm it works ;).

Strange, because the second patch simply applies pad removal to more data frames. So, if the first patch didn't work for ACKs, the second one shouldn't either.

Or wasn't the first one applicable to your sources?

(follow-up: ↓ 6 ) 10/03/07 22:22:22 changed by Mister_X

I applied the first one manually.

I suppose I made a mistake somewhere with the first patch. I'll retry.

(in reply to: ↑ 5 ) 11/15/07 15:15:13 changed by jal2@gmx.de

Replying to Mister_X:

I applied the first one manually. I suppose I made a mistake somewhere with the first patch. I'll retry.

Any results?

(in reply to: ↑ description ; follow-up: ↓ 8 ) 11/15/07 18:14:22 changed by anonymous

i hope you will fix this soon, since some of the aircrack-ng tools don't work anymore because of this bug:/ i'm afraid i can't really help in fixing this, but i'd be willing to test if that helps?!

(in reply to: ↑ 7 ) 11/15/07 22:52:53 changed by anonymous

Replying to anonymous:

i hope you will fix this soon, since some of the aircrack-ng tools don't work anymore because of this bug:/ i'm afraid i can't really help in fixing this, but i'd be willing to test if that helps?!

I'm waiting for testers, please try the second patch (rx_capture_restrict_pad_removal_to_wds_and_qos_frames.patch) and come back with the result.

It worked in a quick test in my environment (for CTS, I didn't see any ACK).

11/16/07 00:38:34 changed by mentor

Try this patch. It stops the attempted removal of padding when there is no frame body, and hence the moving of data into nothingness.

11/16/07 00:42:10 changed by mentor

  • attachment madwifi-nopad_control_frames.diff added.

11/21/07 23:15:06 changed by Mister_X

mentor, I tried on a recent revision and it seems to work. I wanted to test injection but to be sure it is not breaking anything but I had a kernel panic (#1660). I don't think it is due to this patch. I'll try a working revision and report back.

11/28/07 21:49:21 changed by mentor

  • attachment madwifi-nopad_control_frames.2.diff added.

Merged up to r2990

11/28/07 21:50:32 changed by mentor

I've merged the patch up to head; I think the crash is unrelated to this patch...

11/29/07 20:40:34 changed by turbotorben

i've just tried it, kernel panic on injection is gone. and i don't get the errors in wesside-ng anymore (but it still doesn't really work;)

11/30/07 11:16:29 changed by mentor

Any chance that you would elaborate on the not really working bit? Is the not really working bit related to missing data in captured frames?

04/23/08 06:58:59 changed by smaskell

Did this issue ever get resolved or have patches merged into stable code?

I'm running 0.9.4 stable and using latest kismet. It seems all ACK and CTS frames are truncated. The frame control, duration and first four bytes of the receiver address are in the frame but that is all. Seems to be missing a couple of bytes.

I am willing to test whatever patches might be available I just want to make sure they're still current as it's been some time since this defect has seen any activity.

04/24/08 16:27:25 changed by smaskell

Never mind. I installed latest from trunk and both ACK and CTS frames are now complete. Thanks